package meta.system.objectpools;

import org.apache.commons.pool.impl.GenericObjectPool;

import meta.system.registry.Cacheable;

/**
 * Cacheables that are also Pooled shoudl implement this interface. With it Augmentation adds a handle on the object pool and
 * defines logic to return to the object to the pool after it has been deregistered from its cache.
 * @author tom
 */
public interface CachedAnPooled extends Cacheable {
	public void setPool(GenericObjectPool pool);
}
