package meta.system.registry;

import org.apache.log4j.Logger;
import meta.system.registry.exceptions.RegistrationException;

public aspect RegistableAugment {

	static final Logger log = Logger.getLogger("Augment");
	
	public String Registable.name = null;
	public Registry Registable.parent = null;
	
	
	public void Registable.setParent(Registry parent){
		this.parent = parent;
	}
	
	public Registry Registable.getParent(){return parent;}
	

	public void Registable.setName(String name){
		this.name = name;
	}
	
	public String Registable.getName(){
		if(name == null){
			name = this.provideName();
		}
		return name;
	}
	
	public String Registable.provideName(){
		return "PleaseImplementProvideForThisEntity";
	}

	/**
	 * Does nothing, essentailly creates an abtract method on the interface.
	 */
	public void Registable.registering() throws Exception{return;}
	/**
	 * Does nothing, essentailly creates an abtract method on the interface.
	 */
	public void Registable.registered() throws Exception{return;}

	/**
	 * Does nothing, essentailly creates an abtract method on the interface.
	 */
	public void Registable.deregistering() throws Exception{return;}
	/**
	 * Does nothing, essentailly creates an abtract method on the interface.
	 */
	public void Registable.deregistered() throws Exception{return;}
	
}
